#include <iostream>
#include <map>
#include <set>
#include <vector>

static int dsu_root(std::vector<int>& roots, int x) {
    if (roots[x] == x) return x;
    roots[x] = dsu_root(roots, roots[x]);
    return roots[x];
}

int main() {
    int n = 0, e = 0, p = 0;
    std::cin >> n >> e >> p;
    std::vector<std::vector<int>> nodes;
    std::set<std::pair<int,int>> edges;
    std::vector<std::pair<int,int>> edgelist;
    std::vector<int> roots;
    nodes.resize(n+1);
    roots.resize(n+1);
    while ((e--) > 0) {
        int a = 0, b = 0;
        std::cin >> a >> b;
        nodes[a].push_back(b);
        nodes[b].push_back(a);
        edges.insert(std::make_pair(a,b));
        edges.insert(std::make_pair(b,a));
        edgelist.push_back(std::make_pair(a,b));
    }
    while ((p--) > 0) {
        int m = 0, r = 0;
        std::cin >> m;
        if (m < 60) {
            std::vector<int> nodei;
            nodei.resize(m);
            while ((m--) > 0) {
                int a = 0;
                std::cin >> a;
                nodei[m] = a;
                roots[a] = a;
            }
            for (size_t i = 0; i < nodei.size(); i++) {
                int ni = nodei[i];
                for (size_t j = 0; j < i; j++) {
                    int nj = nodei[j];
                    if (edges.count(std::make_pair(ni,nj))) {
                        int p = dsu_root(roots, ni);
                        int q = dsu_root(roots, nj);
                        if (p < q) roots[q] = p;
                        else if (p > q) roots[p] = q;
                    }
                }
            }
            for (size_t i = 0; i < nodei.size(); i++) {
                int ni = nodei[i];
                if (roots[ni] == ni) r++;
            }
        }
        else {
            std::vector<bool> nodei;
            nodei.resize(n+1);
            while ((m--) > 0) {
                int a = 0;
                std::cin >> a;
                nodei[a] = true;
                roots[a] = a;
            }
            for (size_t i = 0; i < edgelist.size(); i++) {
                std::pair<int,int> edge = edgelist[i];
                if (nodei[edge.first] && nodei[edge.second]) {
                    int p = dsu_root(roots, edge.first);
                    int q = dsu_root(roots, edge.second);
                    if (p < q) roots[q] = p;
                    else if (p > q) roots[p] = q;
                }
            }
            for (size_t i = 0; i < nodei.size(); i++) {
                if (nodei[i] && roots[i] == (int)i) r++;
            }
        }
        std::cout << r << std::endl;
    }
    return 0;
}
